> For the complete documentation index, see [llms.txt](https://docs.defisaver.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.defisaver.com/actions/ether.fi/etherfistake.md).

# EtherFiStake

### Description

Supplies ETH (action receives WETH) to EtherFi for ETH2 Staking. Receives eETH in return or weETH in case of wrapping

> **Notes**
>
> ```
> This action:
> 1. Pulls weth
> 2. Transforms it into eth
> 3. Stakes it with EtherFi
> 4. Receives eETH
> 5. If shouldWrap is true, wraps eETH to weETH
> 6. Sends tokens to target address
> ```

### Action ID

`0x7104bb41`

### SDK Action

```ts
const etherFiStakeAction = new dfs.actions.etherfi.EtherFiStakeAction(
    amount,
    from,
    to,
    shouldWrap
);
```

### Action Type

`STANDARD_ACTION`

### Input Parameters

```solidity
    /// @param amount - amount of WETH to pull
    /// @param from - address from which to pull WETH from
    /// @param to - address where received eETH will be sent to
    /// @param shouldWrap - true if received eETH should be wrapped to weETH
    struct Params {
        uint256 amount;
        address from;
        address to;
        bool shouldWrap;
    }
```

### Return Value

```solidity
return or weETH in case of wrapping
contract EtherFiStake is ActionBase, EtherFiHelper {
    using TokenUtils for address;
```

### Events and Logs

```solidity
emit ActionEvent("EtherFiStake", logData);
logger.logActionDirectEvent("EtherFiStake", logData);
bytes memory logData = abi.encode(params);
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.defisaver.com/actions/ether.fi/etherfistake.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
